Summary: GNU Compiler Collection
Name: gcc
Version: 3.3
Release: 5tr
License: GPL
Group: Programming/Compilers
Source0: ftp://ftp.gnu.org/gnu/gcc/gcc-%{version}/gcc-%{version}.tar.bz2
Source1: gcc-3.2.2-fixinc.sh.trustix
Patch1: gcc-3.3-nofix.patch
Patch2: gcc-3.3-infohtml.patch
BuildRoot: /var/tmp/%{name}-%{version}-root
Obsoletes: egcs

Requires: binutils >= 2.12
Requires: cpp = %{version}
Requires: %{name}-runtime = %{version}

Prereq: htmlinfo
BuildRequires: texinfo

%description
The gcc package contains the GNU Compiler Collection: cc and gcc. You'll need
this package in order to compile C code.

%package runtime
Summary: C runtime environment
Group: Libraries/Runtime

%description runtime
This is the C runtime part of the GNU Compiler Collection.  There may be
a few C programs linked against this library.

%package c++-runtime
Summary: C++ runtime environment
Group: Libraries/Runtime
Provides: gcc-c++

%description c++-runtime
This is the C++ runtime part of the GNU Compiler Collection.  You'll need
this package to run C++ programs linked against libstdc++.

%package c++-devel
Summary: C++ development environment
Group: Libraries/Development
PreReq: gcc

%description c++-devel
This is the C++ development part of the GNU Compiler Collection.  You'll need
this package to compile C++ programs.

%package -n cpp
Summary: Objc development environment
Group: Libraries/Development

%description -n cpp
This is the C Pre Processor.  Needed to compile.


%prep
%setup -q
%patch1 -p1
%patch2 -p1

%build
rm -fr obj-%{_target_platform}
mkdir obj-%{_target_platform}
cd obj-%{_target_platform}

CFLAGS="`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g'` -fexceptions" \
	CXXFLAGS="`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g'` -fexceptions" \
	XCFLAGS="`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g'` -fexceptions" \
	TCFLAGS="`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g'` -fexceptions" \
	LANGUAGES="c,c++" \
	../configure --prefix=%{_prefix} \
	--mandir=%{_mandir} \
	--infodir=/usr/share/html \
	--enable-shared \
	--enable-threads \
	--enable-haifa \
	--enable-long-long \
	--enable-__cxa_atexit \
	--host=%{_target_platform}
numprocs=`cat /proc/cpuinfo | grep processor | wc | cut -c7`
if [ "x$numprocs" = "x" -o "x$numprocs" = "x0" ]; then
  numprocs=1
fi
touch ../gcc/c-gperf.h

make -j$numprocs bootstrap-lean

# Make protoize
make -C gcc CC="./xgcc -B ./ -O2" proto
cd ..

%install
# Needed for shortcircuit
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT/%{_mandir}
pushd obj-%{_target_platform}
%makeinstall

# Convert info pages to man format.
#for i in $(find $RPM_BUILD_ROOT -name \*\.info -print); do
#	j=$(basename $i | sed -e 's/\./_/g' -e 's/$/.1/')
#	info2man $i $RPM_BUILD_ROOT/%{_mandir}/man1/$j
#done

# Install fixincludes
mkdir -p $RPM_BUILD_ROOT/usr/sbin
install -m755 ./gcc/fixinc/fixincl $RPM_BUILD_ROOT/usr/sbin/fixincl
install -m755 %{SOURCE1} $RPM_BUILD_ROOT/usr/sbin/fixinc.sh
pushd $RPM_BUILD_ROOT/usr/lib/gcc-lib/%{_target_platform}/%{version}
  mv include ../..
  ln -s ../../include .
  popd

popd

# Manually install htmlinfo pages
mkdir -p $RPM_BUILD_ROOT/usr/share/html/%{name}
install -m 644 gcc/doc/*.html $RPM_BUILD_ROOT/usr/share/html/%{name}/

# We need execute permission on these
chmod a+x $RPM_BUILD_ROOT/usr/lib/*.so*

# cc is a nice default
pushd $RPM_BUILD_ROOT/usr/bin
  ln -s gcc cc
popd

# Some people need cpp under /lib
mkdir $RPM_BUILD_ROOT/lib
pushd $RPM_BUILD_ROOT/lib
  ln -s ../usr/bin/cpp cpp
popd


%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

%post
/usr/sbin/htmlinfo_update.sh
/sbin/ldconfig

%postun
/usr/sbin/htmlinfo_update.sh
/sbin/ldconfig

%files
%defattr(-,root,root)
/usr/bin/cc
/usr/bin/gcc
/usr/bin/gccbug
/usr/bin/gcov
/usr/bin/i586-trustix-linux-gcc
/usr/bin/i586-trustix-linux-gcc-%{version}
/usr/bin/protoize
/usr/bin/unprotoize

/usr/sbin/fixinc.sh
/usr/sbin/fixincl

#/usr/include/gc.h
#/usr/include/gc_*

# We'll leave this to filesystem
# %dir %attr(0755,root,root) /usr/lib/gcc-lib
%dir %attr(0755,root,root) /usr/lib/gcc-lib/%{_target_platform}
%dir %attr(0755,root,root) /usr/lib/gcc-lib/%{_target_platform}/%{version}
/usr/lib/gcc-lib/%{_target_platform}/%{version}/cc1
/usr/lib/gcc-lib/%{_target_platform}/%{version}/collect2
/usr/lib/gcc-lib/%{_target_platform}/%{version}/crtbegin.o
/usr/lib/gcc-lib/%{_target_platform}/%{version}/crtbeginS.o
/usr/lib/gcc-lib/%{_target_platform}/%{version}/crtbeginT.o
/usr/lib/gcc-lib/%{_target_platform}/%{version}/crtend.o
/usr/lib/gcc-lib/%{_target_platform}/%{version}/crtendS.o
/usr/lib/gcc-lib/%{_target_platform}/%{version}/include
/usr/lib/gcc-lib/include
/usr/lib/gcc-lib/%{_target_platform}/%{version}/libgcc.a
/usr/lib/gcc-lib/%{_target_platform}/%{version}/libgcc_eh.a
/usr/lib/gcc-lib/%{_target_platform}/%{version}/specs
/usr/lib/gcc-lib/%{_target_platform}/%{version}/SYSCALLS.c.X
/usr/lib/libgcc_s.so

%{_mandir}/man1/gcc.1*
%{_mandir}/man1/gcov.1*
%{_mandir}/man7/fsf-funding.7*
%{_mandir}/man7/gfdl.7*
%{_mandir}/man7/gpl.7*

/usr/share/html/%{name}

%files runtime
%defattr(-,root,root)
/usr/lib/libgcc_s.so.1

%files c++-runtime
%defattr(-,root,root)
/usr/lib/libstdc++.so.*

%files c++-devel
%defattr(-,root,root)
/usr/bin/c++
/usr/bin/g++
/usr/bin/i586-trustix-linux-c++
/usr/bin/i586-trustix-linux-g++
/usr/include/c++
/usr/lib/gcc-lib/%{_target_platform}/%{version}/cc1plus
/usr/lib/lib*c++.a
/usr/lib/lib*c++.la
/usr/lib/lib*c++.so
%{_mandir}/man1/g++*

%files -n cpp
%defattr(-,root,root)
/lib/cpp
/usr/bin/cpp
#/usr/lib/gcc-lib/%{_target_platform}/%{version}/cpp0
#/usr/lib/gcc-lib/%{_target_platform}/%{version}/tradcpp0
%{_mandir}/man1/cpp.1*
#%{_mandir}/man1/cpp_info.1*
#%{_mandir}/man1/cppinternals_info.1*

%changelog
* Mon Jun 23 2003 Erlend Midttun <erlendbm at trustix dot com> 3.3-5tr
- Added %defattr.

* Wed Jun 18 2003 Erlend Midttun <erlendbm at trustix dot com> 3.3-4tr
- Big rebuild

* Thu Jun  5 2003 Erlend Midttun <erlendbm at trustix dot com> 3.3-3em
- No longer own /usr/lib/gcc-lib.

* Thu May 22 2003 Erlend Midttun <erlendbm at trustix dot com> 3.3-2em
- Removed libiberty to avoid conflict.

* Fri May 16 2003 Erlend Midttun <erlendbm at trustix dot com> 3.3-1em
- New upstream -> 3.3
- Now create htmlinfo pages

* Wed May 14 2003 Erlend Midttun <erlendbm at trustix dot com> 3.2.3-2em
- Fixed the ownership of /usr/lib/gcc-lib/i586...

* Thu Apr 24 2003 Erlend Midttun <erlendbm at trustix dot com> 3.2.3-1em
- New upstream.

* Mon Mar 24 2003 Erlend Midttun <erlendbm at trustix dot com> 3.2.2-4em
- Rebuilt against glibc 2.3.2.

* Tue Mar 11 2003 Erlend Midttun <erlendbm at trustix dot com> 3.2.2-3em
- Kick out java, objc and f77 packages.

* Tue Mar 11 2003 Erlend Midttun <erlendbm at trustix dot com> 3.2.2-2em
- Eh?  No changelog

* Wed Feb 19 2003 Erlend Midttun <erlendbm at trustix dot com> 3.2.2-1em
- New version 3.2.2
- Attempt to fix the include file stuff

* Sat Jan 18 2003 Gerald Dachs <gda at trustix dot org> 3.2.1-2gd
- recompiled against openssl 0.9.7-1gd

* Mon Dec  2 2002 Erlend Midttun <erlendbm at trustix dot com> 3.2.1-1em
- New upstream version.

* Wed Nov 20 2002 Erlend Midttun <erlendbm at trustix dot com> 3.2-5em
- Created a gcc-runtime to avoid having a dependency on the full gcc package.

* Fri Sep 13 2002 Erlend Midttun <erlendbm at trustix dot com> 3.2-4em
- Added /lib/cpp
- Trying to use only --enable-threads

* Fri Sep  6 2002 Erlend Midttun <erlendbm at trustix dot com> 3.2-3em
- Fix libgcc.so
- Fixed %dir on the compiler dir
- Added default attributes.
- Remove info files for now.
- Added .so's to file lists.

* Fri Aug 23 2002 Erlend Midttun <erlendbm at trustix dot com> 3.2-2em
- Added Provides gcc-c++
- Fixed files section of c++

* Wed Aug 21 2002 Erlend Midttun <erlendbm at trustix dot com> 3.2-1em
- Take 3.2

* Wed Jul 24 2002 Christian H. Toldnes <christht at trustix dot com> 3.1-2ct
- Added ada, fortran, objective c, and java support

* Wed Jul 24 2002 Christian H. Toldnes <christht at trustix dot com> 3.1-1ct
- initial release of version 3.1 for TSL
- Only one really big package for now, to ensure all files gets included.

* Tue Feb 26 2002 Erlend Midttun <erlendbm at trustix dot com>
- Added atexit patch.

* Mon Mar 26 2001 Oystein Viggen <oysteivi at trustix dot com>
- Upgrade to v2.95.3
- Handle gzipped man files

* Wed Mar 29 2000 Lars Gaarden <larsg at trustix dot com>
- Moved man and info pages to /usr/share, FHS.

* Sat Dec 11 1999 Bernhard Rosenkraenzer <bero@redhat.com>
- Obsolete egcs*, g77
- Add egcs 1.1.x'ish libstdc++ versions to libstdc++-compat

* Wed Dec  8 1999 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix build on sparc

* Tue Dec  7 1999 Bernhard Rosenkraenzer <bero@redhat.com>
- Add -warn patch (adapted from egcs-1.1.2 RPM)
- drop release number to 1 for 7.0 tree

* Tue Oct 26 1999 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.95.2 release

* Sun Oct 24 1999 Bernhard Rosenkraenzer <bero@redhat.com>
- initial RPM

